#PurePDF_Include=1
XIncludeFile "PurePDF.pb"

Define link

CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Linux
    #ZLIB_IMPORT_PATH = #PB_Compiler_Home + "purelibraries/linux/libraries/zlib.a"
  CompilerCase #PB_OS_Windows
    #ZLIB_IMPORT_PATH = "zlib.lib"
  CompilerCase #PB_OS_MacOS
    #ZLIB_IMPORT_PATH = "/usr/lib/libz.dylib"
CompilerEndSelect

ImportC #ZLIB_IMPORT_PATH
  compress.l(*dest, *destlen, *source, sourcelen)
EndImport

Procedure.l PDFCompress(*aData.MEM_DataStructure)
  Protected zerr,CompMem,SourceLen,SourceMem,CompLen,lbError
  
  lbError = #False
  SourceLen = *aData\lCurSize
  SourceMem = *aData\pData 
  CompLen   = Round(1.001 * SourceLen,#PB_Round_Up) + 12
  CompMem   = AllocateMemory(CompLen)
  If CompMem
    zerr=compress(CompMem,@CompLen,SourceMem,SourceLen)
    If zerr = 0
      *aData\pData = CompMem
      *aData\lMaxSize = CompLen
      *aData\lCurSize = CompLen
      FreeMemory(Sourcemem)
      lbError = #True 
    EndIf
  EndIf
  ProcedureReturn lbError  
EndProcedure

;Adding internal and external links.
Define file$="Tutorial07 Images.pdf"

pdf_Create()
pdf_SetProcCompression(@PDFCompress())
pdf_AddPage()
pdf_SetFont("Arial","",20)
pdf_Write(5,"To find out what's new in this tutorial, click ")
pdf_SetFont("","U")
link = pdf_Addlink()
pdf_SetLink(link,0,2)
pdf_Write(5,"here", link)

pdf_Image("ringmaster.wmf",10,50,110)

pdf_AddPage()
link = pdf_Addlink()
pdf_SetLink(link,-1,-1,"http://www.smollies.be")

pdf_Image("PurePDFLogo.png",10,10,30,0,link)
pdf_AddPage()
pdf_Image("PurePDFLogo.jpg",10,10,190,0,link)

pdf_Save(file$)
RunProgram(file$)
; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 1
; Folding = -